#!/usr/bin/env node
'use strict'
/**
 * @author github.com/tintinweb
 * @license MIT
 * */
const request = require('request');

const rexQuoted = /'(.*?)'/g;
const rexValid = /^[a-z0-9]{3,}$/i;

function getBuiltInsFromAntlrGrammar() {
    return new Promise((resolve, reject) => {
        request.get('https://raw.githubusercontent.com/solidity-parser/antlr/master/Solidity.g4', (err, res, body) => {
            if (err) {
                return reject(err)
            } else {
                const array = Array.from(new Set([...body.matchAll(rexQuoted)].map(m => m[1].trim()))).filter(fi => rexValid.test(fi) );
                return resolve(array);
            }
        })
    });
}


getBuiltInsFromAntlrGrammar().then(b => {
    console.log(`'use strict'
/**
 * @author github.com/tintinweb
 * @license MIT
 * */
    
//autogenerated with # npm run updateBuiltIns
module.exports.builtIns = ${JSON.stringify(b, null, 4)}`);
})

